program wert;


uses dos,crt;


const
    parametr : array [1..6] of string[3] = ('KD1','KD2','TX1','TX2','PX1','PX2');
    p_majuskuly : array [1..7] of string[1] = ('A','C','E','L','N','O','S');
    p_minuskuly : array [1..7] of string[1] = ('a','c','e','l','n','o','s');
    t_majuskuly : array [1..7] of string[5] = ('\''C','\L{}','\''N','\''O','\''S','\''Z','\.Z');
    t_minuskuly : array [1..7] of string[5] = ('\''c','\l{}','\''n','\''o','\''s','\''z','\.z');
    niewlasciwa : string[36] = ('Niewlasciwa zmienna srodowiskowa -  ');
    niedobry : string[24] = ('Niedobry przelacznik -  ');


var
    plik : string;
    wejscie, wyjscie : string[3];
    kodwe, kodwy : array [1..18] of string[5];
    kd1, kd2 : string[18];
    tx0, tx1, tx2 : string[1];
    lancuch : string[5];
    px0, px1, px2 : string[1];
    zz0, zz1, zz2 : string[4];
    lancuchwewy : array [1..18] of string[5];
    bool : boolean;
    sciezka: searchrec;
    atrybut : word;
    czas : longint;
    p: pathstr;
    d: dirstr;
    n: namestr;
    e: extstr;


procedure pomoc;
begin
    writeln('Konwertuje pliki tekstowe miedzy wybranymi kodami i notacjami.');
    writeln;
    writeln('WERT [[dysk:[sciezka]]nazwapliku] [KD?|TX?|PX?] [KD?|TX?|PX?] [TEST]');
    writeln;
    writeln('  [dysk:[sciezka]]nazwapliku');
    writeln('          Plik lub pliki do konwersji.');
    writeln('  KD1, KD2, TX1, TX2, PX1, PX2');
    writeln('          Wejscie i wyjscie (kody znakowe, notacje techowe, notacje prefiksowe).');
    writeln('  TEST    Informacja o zmiennych srodowiskowych.');
    halt(0);
end;


procedure cmk;
begin
    writeln('WERT 2.00, Cezary M. Kruk, 1998.');
    halt(0);
end;


procedure test;
begin
    write('KD1=', kd1);
    gotoxy(25, wherey);
    write('TX1=', tx1);
    gotoxy(32, wherey);
    write('PX1=', px1);
    gotoxy(39, wherey);
    writeln('ZZ1=', zz1);
    write('KD2=', kd2);
    gotoxy(25, wherey);
    write('TX2=', tx2);
    gotoxy(32, wherey);
    write('PX2=', px2);
    gotoxy(39, wherey);
    writeln('ZZ2=', zz2);
    halt(0);
end;


procedure blad0;
begin
    writeln('WERT: Nieznany format parametru');
    halt(0);
end;


procedure blad1;
begin
    writeln('Zbyt wiele parametrow');
    halt(0);
end;


procedure blad2;
begin
    writeln('Bez konwersji');
    halt(0);
end;


procedure blad3a;
begin
    writeln(niedobry, paramstr(2));
    halt(0);
end;


procedure blad3b;
begin
    writeln(niedobry, paramstr(3));
    halt(0);
end;


procedure blad4a;
begin
    writeln(niewlasciwa, 'KD1');
    halt(0);
end;


procedure blad4b;
begin
    writeln(niewlasciwa, 'TX1');
    halt(0);
end;


procedure blad4c;
begin
    writeln(niewlasciwa, 'PX1 lub ZZ1');
    halt(0);
end;


procedure blad4d;
begin
    writeln(niewlasciwa, 'KD2');
    halt(0);
end;


procedure blad4e;
begin
    writeln(niewlasciwa, 'TX2');
    halt(0);
end;


procedure blad4f;
begin
    writeln(niewlasciwa, 'PX2 lub ZZ2');
    halt(0);
end;


procedure blad5a;
begin
    writeln('Nie odnaleziono pliku');
    halt(0);
end;


procedure blad5b;
begin
    writeln('Dostep zabroniony -  ',d+sciezka.name);
    halt(0);
end;


procedure odczytzmiennych;
begin
    swapvectors;
    kd1:=getenv('KD1');
    tx1:=getenv('TX1');
    px1:=getenv('PX1');
    zz1:=getenv('ZZ1');
    kd2:=getenv('KD2');
    tx2:=getenv('TX2');
    px2:=getenv('PX2');
    zz2:=getenv('ZZ2');
    swapvectors;
end;


procedure testparametrow;
var
    i : integer;
begin
    if (paramcount=0) or (paramstr(1)='/?') then pomoc;
    if paramstr(1)='\?' then cmk;
    plik:=paramstr(1);
    for i:=1 to length(plik) do plik[i]:=upcase(plik[i]);
    if (paramcount=1) and (plik='TEST') then test;
    if (paramcount=1) or (paramcount=2) then blad0;
    if paramcount>3 then blad1;
    wejscie:=paramstr(2);
    wyjscie:=paramstr(3);
    for i:=1 to length(wejscie) do wejscie[i]:=upcase(wejscie[i]);
    for i:=1 to length(wyjscie) do wyjscie[i]:=upcase(wyjscie[i]);
    if wejscie=wyjscie then blad2;
    bool:=FALSE;
    for i:=1 to 6 do if wejscie=parametr[i] then bool:=TRUE;
    if not bool then blad3a;
    bool:=FALSE;
    for i:=1 to 6 do if wyjscie=parametr[i] then bool:=TRUE;
    if not bool then blad3b;
end;


procedure testsrodowiska;
begin
    if ((wejscie='KD1') or (wyjscie='KD1'))
        then if (length(kd1)<18) then blad4a;
    if ((wejscie='TX1') or (wyjscie='TX1'))
        then if (length(tx1)<1) then blad4b;
    if ((wejscie='PX1') or (wyjscie='PX1'))
        then if ((length(px1)<1) or (length(zz1)<4)) then blad4c;
    if ((wejscie='KD2') or (wyjscie='KD2'))
        then if (length(kd2)<18) then blad4d;
    if ((wejscie='TX2') or (wyjscie='TX2'))
        then if (length(tx2)<1) then blad4e;
    if ((wejscie='PX2') or (wyjscie='PX2'))
        then if ((length(px2)<1) or (length(zz2)<4)) then blad4f;
end;


procedure testpliku;
begin
    findfirst(plik, archive, sciezka);
    assign(input, d+sciezka.name);
    getfattr(input, atrybut);
    if doserror=3 then blad5a;
    p:=plik;
    fsplit(p, d, n, e);
    findfirst(plik, archive, sciezka);
        repeat
            assign(input, d+sciezka.name);
            getfattr(input, atrybut);
            if atrybut and readonly<>0 then blad5b;
            findnext(sciezka);
        until doserror=18;
end;


procedure prefiks;
var
    i : integer;
begin
    for i:=1 to 7 do
        lancuchwewy[i]:=concat(px0, p_majuskuly[i]);
    for i:=8 to 9 do
        lancuchwewy[i]:=concat(px0, zz0[i-7]);
    for i:=10 to 16 do
        lancuchwewy[i]:=concat(px0, p_minuskuly[i-9]);
    for i:=17 to 18 do
        lancuchwewy[i]:=concat(px0, zz0[i-14]);
end;


procedure tex;
var
    i : integer;
begin
    lancuchwewy[1]:=concat('\',tx0,'{A}');
    lancuchwewy[2]:=t_majuskuly[1];
    lancuchwewy[3]:=concat('\',tx0,'{E}');
    for i:=4 to 9 do
        lancuchwewy[i]:=t_majuskuly[i-2];
    lancuchwewy[10]:=concat('\',tx0,'{a}');
    lancuchwewy[11]:=t_minuskuly[1];
    lancuchwewy[12]:=concat('\',tx0,'{e}');
    for i:=13 to 18 do
        lancuchwewy[i]:=t_minuskuly[i-11];
end;


procedure wejsciewyjscie;
var
    i : integer;
begin
    if wejscie='KD1' then
        for i:=1 to 18 do
            kodwe[i]:=kd1[i];
    if wejscie='KD2'then
        for i:=1 to 18 do
            kodwe[i]:=kd2[i];
    if wejscie='PX1' then
        begin
            px0:=px1;
            zz0:=zz1;
            prefiks;
            for i:=1 to 18 do
                kodwe[i]:=lancuchwewy[i];
        end;
    if wejscie='PX2' then
        begin
            px0:=px2;
            zz0:=zz2;
            prefiks;
            for i:=1 to 18 do
                kodwe[i]:=lancuchwewy[i];
        end;
    if wejscie='TX1' then
        begin
            tx0:=tx1;
            tex;
            for i:=1 to 18 do
                kodwe[i]:=lancuchwewy[i];
        end;
    if wejscie='TX2' then
        begin
            tx0:=tx2;
            tex;
            for i:=1 to 18 do
                kodwe[i]:=lancuchwewy[i];
        end;
    if wyjscie='KD1' then
        for i:=1 to 18 do
            kodwy[i]:=kd1[i];
    if wyjscie='KD2'then
        for i:=1 to 18 do
            kodwy[i]:=kd2[i];
    if wyjscie='PX1' then
        begin
            px0:=px1;
            zz0:=zz1;
            prefiks;
            for i:=1 to 18 do
                kodwy[i]:=lancuchwewy[i];
        end;
    if wyjscie='PX2' then
        begin
            px0:=px2;
            zz0:=zz2;
            prefiks;
            for i:=1 to 18 do
                kodwy[i]:=lancuchwewy[i];
        end;
    if wyjscie='TX1' then
        begin
            tx0:=tx1;
            tex;
            for i:=1 to 18 do
                kodwy[i]:=lancuchwewy[i];
        end;
    if wyjscie='TX2' then
        begin
            tx0:=tx2;
            tex;
            for i:=1 to 18 do
                kodwy[i]:=lancuchwewy[i];
        end;
end;


procedure zamien;
var
    a, i : integer;
begin
    i:=0;
    while (i<18) and not bool do
        begin
            i:=i+1;
            bool:=lancuch=kodwe[i]
        end;
    if bool then write(kodwy[i]);
end;


procedure kod_wyjscie;
var
    ch1 : char;
    i : integer;
begin
    while not eof do
        begin
            read(ch1);
            lancuch:=ch1;
            bool:=FALSE;
            if ord(ch1)>127 then zamien;
            if not bool then write(ch1);
        end
end;


procedure pfx_wyjscie;
var
    ch1, ch2 : char;
    i : integer;
begin
while not eof do
    begin
        read(ch1);
        if (ch1=px1) or (ch1=px2) and not eof then
            begin
                read(ch2);
                lancuch:=concat(ch1, ch2);
                bool:=FALSE;
                zamien;
                if not bool then write(lancuch);
            end
            else
            write(ch1)
    end
end;


procedure tex_wyjscie;
var
    lancuch0 : string[5];
    a, i, j : integer;
begin
    a:=1;
    while not eof do
        begin
            for i:=1 to 6-a do
                for j:=1 to 4 do
                    lancuch0[j]:=lancuch0[j+1];
            for i:=a to 5 do
                read(lancuch0[i]);
                    if (lancuch0[1]='\') then
                        begin
                            bool:=FALSE;
                            lancuch:=concat(lancuch0[1], lancuch0[2], lancuch0[3]);
                            if (lancuch=kodwe[2])
                            or (lancuch=kodwe[5])
                            or (lancuch=kodwe[6])
                            or (lancuch=kodwe[7])
                            or (lancuch=kodwe[8])
                            or (lancuch=kodwe[9])
                            or (lancuch=kodwe[11])
                            or (lancuch=kodwe[14])
                            or (lancuch=kodwe[15])
                            or (lancuch=kodwe[16])
                            or (lancuch=kodwe[17])
                            or (lancuch=kodwe[18]) then
                                begin
                                    a:=3;
                                    zamien;
                                end
                            else
                            begin
                                lancuch:=concat(lancuch, lancuch0[4]);
                                if (lancuch=kodwe[4])
                                or (lancuch=kodwe[13]) then
                                    begin
                                        a:=2;
                                        zamien;
                                    end
                                else
                                begin
                                    lancuch:=concat(lancuch, lancuch0[5]);
                                    if (lancuch=kodwe[1])
                                    or (lancuch=kodwe[3])
                                    or (lancuch=kodwe[10])
                                    or (lancuch=kodwe[12]) then
                                        begin
                                            a:=1;
                                            zamien;
                                        end;
                                end;
                            end;
                            if not bool then
                                begin
                                    a:=5;
                                    write('\');
                                end;
                        end
                        else
                        begin
                            a:=5;
                            write(lancuch0[1]);
                        end;
        end;
    for i:=7-a to 5 do
    write(lancuch0[i]);
end;


procedure metoda;
begin
    if (wejscie='KD1') or (wejscie='KD2') then kod_wyjscie;
    if (wejscie='PX1') or (wejscie='PX2') then pfx_wyjscie;
    if (wejscie='TX1') or (wejscie='TX2') then tex_wyjscie;
end;


procedure kopiowanie;
var
    a : char;
    buforwe, buforwy : array[1..1024] of byte;
begin
    settextbuf(input, buforwe);
    settextbuf(output, buforwy);
    reset(input);
    rewrite(output);
    while not eof(input) do
        begin
            read(input, a);
            write(output, a);
        end;
    close(input);
    close(output);
end;


procedure konwersja;
begin
    writeln('Konwersja z ', wejscie, ' do ', wyjscie);
    findfirst(plik, archive, sciezka);
        repeat
            assign(input, d+sciezka.name);
            reset(input);
            assign(output, d+'wert.bak');
            rewrite(output);
            getftime(input, czas);
                metoda;
            close(input);
            close(output);
            assign(input, d+'wert.bak');
            assign(output, d+sciezka.name);
                kopiowanie;
            erase(input);
            reset(output);
            setftime(output, czas);
            close(output);
            findnext(sciezka);
        until doserror=18;
    assigncrt(input);
    reset(input);
    assigncrt(output);
    rewrite(output);
    writeln;
end;


begin
    odczytzmiennych;
    testparametrow;
    testsrodowiska;
    testpliku;
    wejsciewyjscie;
    konwersja;
end.
